﻿using ClosedXML.Excel;
using Newtonsoft.Json.Linq;
using System;
using System.Text;
using System.Windows.Forms;



namespace kintone_sql_editor
{
    public partial class Form1 : Form
    {

        JArray arrKintone = new JArray();
        JObject objTemplate = new JObject();



        /// <summary>
        /// 
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }



        /// <summary>
        /// 
        /// </summary>
        private void readConfig()
        {
            using (var workbook = new XLWorkbook(@"kintone_sql_設定.xlsx"))
            {

                foreach (var worksheet in workbook.Worksheets)
                {
                    var rowCount = worksheet.LastRowUsed().RowNumber();

                    if (worksheet.Name == "設定")
                    {
                        arrKintone.Clear();
                        for (int row_cnt = 1; row_cnt < rowCount; row_cnt++)
                        {
                            JObject kintone_config = new JObject();
                            kintone_config["domain"] = worksheet.Cell(row_cnt + 1, 1).Value.ToString();
                            kintone_config["space_id"] = worksheet.Cell(row_cnt + 1, 2).Value.ToString();
                            kintone_config["app_id"] = worksheet.Cell(row_cnt + 1, 3).Value.ToString();
                            if ((string)kintone_config["app_id"] == "")
                            {
                                break;
                            }
                            arrKintone.Add(kintone_config);
                        }
                        System.IO.File.WriteAllText("arrKintone.json", arrKintone.ToString());
                    }
                    else
                    {

                        JObject objSql = new JObject();
                        JObject objSql2 = new JObject();
                        for (int row_cnt = 1; row_cnt < rowCount; row_cnt++)
                        {
                            string key = (string)worksheet.Cell(row_cnt + 1, 1).Value;
                            string val = (string)worksheet.Cell(row_cnt + 1, 2).Value;
                            objSql2[key] = val;
                        }
                        objSql["sql"] = objSql2;
                        objSql["template"] = (string)worksheet.Cell(1, 2).Value;
                        objTemplate[worksheet.Name] = objSql;
                    }
                }
                objTemplate["kintone"] = arrKintone;
                System.IO.File.WriteAllText("sql.json", objTemplate.ToString());
            }
        }


        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        private string GetValue()
        {
            string base64_str = $"{txtUserid.Text}:{txtPassword.Text}";
            return Convert.ToBase64String(Encoding.UTF8.GetBytes(base64_str));
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            readConfig();
            createTable();
        }


        /// <summary>
        /// 
        /// </summary>
        private void createTable()
        {
            foreach (var item in arrKintone)
            {
                Kintone kintone = new Kintone((string)item["domain"], (int)item["space_id"], (int)item["app_id"], null, GetValue());
                var fields = kintone.GetFieldsRaw();
                if (fields == null)
                {
                    MessageBox.Show("エラーが発生しました。");
                    break;
                }
                sqlite3_lib sqlite3 = new sqlite3_lib();
                string table_name = "tbl" + (string)item["app_id"];
                sqlite3.CreateTable(table_name, fields);

                var records = kintone.GetAllRecords();
                sqlite3.insertData(table_name, fields, records);

                textBox1.AppendText($"{item["app_id"]}" + Environment.NewLine);
            }
            textBox1.AppendText($"----- 完了 -----" + Environment.NewLine);
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            txtUserid.Text = Properties.Settings.Default.user_id;

        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click_1(object sender, EventArgs e)
        {
            readConfig();
            System.IO.File.WriteAllText("kintoneプラグイン設定データ.json", objTemplate.ToString());
            textBox1.AppendText($"kintoneプラグイン設定データ.json を出力しました" + Environment.NewLine);

        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.user_id = txtUserid.Text;
            Properties.Settings.Default.Save();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Kintone kintone = new Kintone("tox1i0lgjy5s", 0, 544, null, GetValue());

            JObject objParam = new JObject();
            objParam["app"] = 544;
            objParam["record"] = new JObject();
            objParam["record"]["集計日"] = new JObject();
            objParam["record"]["集計日"]["value"] = "2024-02-28";
            objParam["record"]["結果1"] = new JObject();
            objParam["record"]["結果1"]["value"] = "2";
            objParam["record"]["結果2"] = new JObject();
            objParam["record"]["結果2"]["value"] = "5";
            objParam["record"]["結果3"] = new JObject();
            objParam["record"]["結果3"]["value"] = "567";

            kintone.upsertData(objParam, "集計日");

            //JObject objParam = new JObject();
            //objParam["app"] = 544;
            //objParam["updateKey"] = new JObject();
            //objParam["updateKey"]["field"] = "集計日";
            //objParam["updateKey"]["value"] = "2024-02-25";
            //objParam["record"] = new JObject();
            //objParam["record"]["結果3"] = new JObject();
            //objParam["record"]["結果3"]["value"] = "345";

            //kintone.updateData(objParam);
        }
    }
}
